% Based on the 

function [pspec,diff,a]=decracore_test(Z,constant,grad2,startspec,endspec,startpoint,endpoint,ncom);


specsize=16384;
data=[];

data = Z(startspec:endspec, startpoint:endpoint);
whos data

%a constant difference between g^2 is necessary
incr=grad2(2)-grad2(1);

%define two ranges (split the data set in  two)
range1=[startspec:endspec-1];
range2=[startspec+1:endspec];

whos range1;
whos range2;


%create a common base for the two data sets using SVD
[vc,sc,uc]=svd(data(range1,:)',0);
sc=sc(1:ncom,1:ncom);
uc=uc(:,1:ncom);
vc=vc(:,1:ncom);
 
%project the two data sets onto the common base
auv=sc;
buv=uc'*data(range2,:)*vc;

%solve the generalized eigenvalue problem
[v,s]=eig(buv*inv(sc));
ev=diag(s);
[ev,sortindex]=sort(diag(s));
v=v(:,sortindex);

%calculate spectra and concentrations
pspec=pinv(vc*inv(sc)*v);
pint=uc*v;

%scale spectra and concentrations
total=sum(data(range1,:)')';
scalefactor=pint\total;
pint=pint*diag(scalefactor);
pspec=diag(1./scalefactor)*pspec;
 
%calculate proper composition
pint2=pint*diag(ev);
nrows=size(pint,1);
pintcomb=[pint(1,:);(pint(2:nrows,:)+pint2(1:nrows-1,:))/2;pint2(nrows,:)];
b=log(ev)/incr;
diff=-b/constant;
grad21=grad2(range1);
grad22=grad2(range2);
grad2comb=[grad21;grad22(nrows)];
for i=1:length(ev);
   expest0=exp(grad2comb*b(i));
   a(i)=expest0\pintcomb(:,i);
end;
pspec=diag(a)*pspec;


%end